 package com.huimv.management.controller;

import java.text.ParseException;
import java.util.*;

import com.huimv.management.dao.EartagDataDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.huimv.management.entity.EartagDataEntity;
import com.huimv.management.service.EartagDataService;
import com.huimv.common.utils.PageUtils;
import com.huimv.common.utils.R;

import static java.lang.Thread.sleep;


 /**
 * 
 *
 * @author yinhao
 * @email yinhao@163.com
 * @date 2021-06-21 10:00:18
 */
@RestController
@RequestMapping("management/eartagdata")
public class EartagDateController {
    @Autowired
    private EartagDataService eartagDateService;

     @Autowired
     private EartagDataDao eartagDataDao  ;



    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params) throws InterruptedException {
        PageUtils page = eartagDateService.queryPage(params);
        return R.ok().put("page", page);
    }


    //睡眠时间处理。这里做简单一点的处理，代码都放在这里了
     @RequestMapping("/sleeptime")
     public R list1(@RequestParam Map<String, Object> params) throws InterruptedException, ParseException {
         List<Map<String,String>> list = eartagDateService.querySleepTimeBytimeAndEartag(params);
         return R.ok().put("data", list);
     }



     @RequestMapping("/searchDateByCondition")
     public R listby(@RequestParam Map<String, Object> params) throws InterruptedException, ParseException {
         Map ResultMap = eartagDateService.queryPageBytimeAndEartag(params);
         return R.ok().put("page", ResultMap);
     }

     /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		EartagDataEntity eartagDate = eartagDateService.getById(id);

        return R.ok().put("eartagDate", eartagDate);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody EartagDataEntity eartagDate){
		eartagDateService.save(eartagDate);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody EartagDataEntity eartagDate){
		eartagDateService.updateById(eartagDate);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		eartagDateService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }


     @RequestMapping("/getTemperatureCurve")
     public R getTemperatureCurve(@RequestParam Map<String, Object> params){

         return R.ok().put("data", eartagDateService.getTemperatureCurve(params));
     }

}
